--[[
-- Check AI call stack (2006/03/31)
stacktrace.lua AĨR[X^bN𒲂ׂĂ݂
http://blog.livedoor.jp/aidev/archives/50249596.html

the author is null. by Ȟ
http://blog.livedoor.jp/aidev/

documentation by silica as ~̐l
http://winter.sgv417.jp/
--]]
do
	local callstack = { n = 0 }
	
	local function Contains( list, value )	-- list  value ܂܂Ă邩
		for i,v in ipairs( list ) do
			if value == v then
				return true
			end
		end
		return false
	end
	
	local function IsIgnoreFunction( name )	-- g[XƃX^bNI[o[̂Ȃ
		return Contains( {"_TRACEBACK","__pow","error","rawequal","tonumber","gcinfo","getfenv","setfenv","setmetatable","getmetatable","collectgarbage","loadlib","loadfile","loadstring","pairs","ipairs","rawset","assert","print","tostring","unpack","next","type","newproxy","rawget"}, name )
	end
	
	local function IsIgnoreTable( name )
		return Contains( {"string","os","io","math","table","coroutine","_G","arg","_LOADED","debug"}, name )
	end
	
	local function Inject( t )
		local stack = { n = 0 } 	-- ݂̃e[ůKwXg
		local function DoInject( t )
			for k,v in pairs( t ) do
				if type( v ) == "function" and not IsIgnoreFunction( k ) then
					local text = ""
					for i,v in ipairs( stack ) do
						text = text..v.."."
					end
					print("inject:",tostring(text)..tostring( k ))
					text = text..tostring( k )
					local func = v
					t[ k ] = function( ... )	-- ֐
						callstack.n = callstack.n + 1
						callstack[ callstack.n ] = text	-- R[X^bNɌ݂̊֐ǉ
						local r = { func( unpack( arg ) ) }	-- {̊֐Ă (߂lΉ)
						callstack[ callstack.n ] = nil	-- R[X^bN菜
						callstack.n = callstack.n - 1
						return unpack( r )
					end
				elseif type( v ) == "table" and not IsIgnoreTable( k ) then
					stack.n = stack.n + 1	-- e[uǉ
					stack[ stack.n ] = tostring( k )
					DoInject( v )
					stack[ stack.n ] = nil
					stack.n = stack.n - 1	-- e[u폜
				end
			end
		end
		DoInject( t )
	end
	
	Inject( _G )
	
	function TraceStack( name )	-- ݂̃X^bNg[X  name ̓x
		local label
		if name then
			label = "\""..name.."\""
		else
			label = "noname"
		end
		local fp = io.open("CallStack.txt","a")
		fp:write("label: "..label.."\n")
		fp:write("date: "..os.date("%c").."\n")
		fp:write("callstack:\n")
		for i,v in ipairs( callstack ) do
			fp:write("\t"..v.."\n")
		end
		fp:write("\n")
		fp:close()
	end
	
	local raw_assert = assert
	function assert( eval )	-- AssertionɃR[X^bNf悤ɂ
		if not eval then
			TraceStack("Assertion Failed")
		end
		raw_assert( eval )
	end
end
